#*************************************************************
# Progamm:			fourier_2
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Ausgabeeinheit
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		fourier_2_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		12.11.2022
#*************************************************************

import numpy as np

#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os

#*************************************************************
# Import der Klasse matplotlib.pyplot für die Graphikausgabe
#*************************************************************
import matplotlib.pyplot as plt

class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")  

#*************************************************************
# Funktion zur Ausgabe in der Konsole
#*************************************************************      
  def schirm_ausgabe(self, x_neu,fourier_temp_cos,fourier_temp_sin,fourier_temp_alle, fourier_meeresspiegel_cos,fourier_meeresspiegel_sin,fourier_meeresspiegel_alle):
    print("Schirmaugabe")
   
    for i in range(len(x_neu)):
      print ("%5i" %i, "%6.5f" %x_neu[i], "%6.5f" %fourier_temp_cos[i], "%6.5f" %fourier_temp_sin[i],"%6.5f" %fourier_temp_alle[i],"%6.5f" %fourier_meeresspiegel_cos[i],\
      "%6.5f" %fourier_meeresspiegel_sin[i],"%6.5f" %fourier_meeresspiegel_alle[i])
     
      
#*************************************************************
# Funktion zur Ausgabe in eine Datei
#*************************************************************
  def datei_ausgabe(self, ausgabe_datei, x_neu, fourier_temp_cos, fourier_temp_sin, fourier_temp_alle, fourier_meeresspiegel_cos, fourier_meeresspiegel_sin, fourier_meeresspiegel_alle):
    fobj_out = open(ausgabe_datei,"w")
    for i in range(len(x_neu)):
      fobj_out.write(str("%5i" %i))
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %x_neu[i]))      
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %fourier_temp_cos[i])) 
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %fourier_temp_sin[i]))      
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %fourier_temp_alle[i]))  
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %fourier_meeresspiegel_cos[i]))      
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %fourier_meeresspiegel_sin[i]))                   
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %fourier_meeresspiegel_alle[i])) 
      fobj_out.write("\n")      
    fobj_out.close()




#*************************************************************
# Funktion zur graphischen Ausgabe
#*************************************************************
  def graphik_ausgabe(self, x, y, graphik_datei_wähler,graphik_datei, graphik_titel, graphik_format):
    x_min=2000.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    m = len(x)
    i_max = m - 1
    for i in range(i_max+1):
      if x_min >= x[i]:
        x_min = x[i]
      if x_max <= x[i]:
        x_max = x[i]
      if y_min >= y[i]:
        y_min = y[i]
      if y_max <= y[i]:
        y_max = y[i]
    plt.plot(x, y,'r') #, 'r.'
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    x_min-=(x_max-x_min)/10.0
    x_max+=(x_max-x_min)/10.0
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title(graphik_titel)
#    plt.xlabel('Zeit [Jahr]')
#    plt.ylabel(graphik_ordinate)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_wähler):
      plt.savefig(graphik_datei + "_" + graphik_titel + "." + graphik_format , format='png')
     # Diagramm anzeigen:
    plt.show()


