#*************************************************************
# Progamm:			fourier_2
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Einlesen der Temperatur- und Meeresspiegeldaten 	
# Name dieser Datei:		datei_einlese.py
# Versionsnummer:		1
# Wird aufgerufen von:		fourier_2_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		03.11.2022
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateifunktionen
#*************************************************************
import os
import numpy as np

class Datei_einlese:

  def __init__(self):		
    print("Datei_leseobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Datei_leseobjekt entfernt")   

  def parameter_datei_input(self, parameter_datei):
    if os.path.exists(parameter_datei):
      fobj_in = open(parameter_datei,"r")
      self.zeilen_zähler = 0;
      for zeile in fobj_in:
        self.zeilen_zähler += 1
      fobj_in.close()
      
      fobj_in = open(parameter_datei,"r")
      for i in range(self.zeilen_zähler):
        zeile=fobj_in.readline()
        if i == 0:  
          self.m_max = int(zeile)
        elif i == 1:
          self.x_min = float(zeile)
        elif i == 2:
          self.x_max = float(zeile)
        else:
          pass  
      fobj_in.close()
      #print(zeile[0], zeile[1], zeile[2])
      print("m=", self.m_max,"x_min= ",self.x_min, "x_max = ", self.x_max)                    
    
#*************************************************************
# Funktion zum Öffnen der ISA-datei und zum Auslesen der
# Atmosphärendaten
#*************************************************************
  def datei_input(self, eingabe_datei):
    rückgabewert = True
    print("Einlesen der Daten aus: "  +  eingabe_datei) 
    if os.path.exists(eingabe_datei):
      fobj_in = open(eingabe_datei,"r") 
      self.zeilen_zähler = 0;
      for zeile in fobj_in:
        self.zeilen_zähler += 1
      fobj_in.close()
      print(self.zeilen_zähler)
      self.spektral_wert =  np.zeros(self.zeilen_zähler)   
      fobj_in.close() 
      fobj_in = open(eingabe_datei,"r") 
      for i in range(self.zeilen_zähler):
        zeile=fobj_in.readline()
        self.puffer = zeile[:-1]
        dummy   = self.puffer.split("\t")
        self.spektral_wert[i]=float(dummy[1])
      fobj_in.close()  
      print("Zeilenzähler = ", self.zeilen_zähler)     
      rückgabewert = True             
    else:
      print("Datei nicht vorhanden")
      rückgabewert = False   
    return rückgabewert
