#*************************************************************
# Progamm:			fourier_2
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		fourier_2_haupt.py
# Versionsnummer:		1
# Wird aufgerufen von:		-
# Ruft auf:			steuer.py, gitter.py, zurueck_rechner.py, ausgabe.py
# Nummer im Programmpaket:	1
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		12.11.2022
#*************************************************************

#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************

import time
import datetime
import sys


#*************************************************************
# Importieren der Klassen
#*************************************************************
from steuer import Steuer
from datei_einlese import Datei_einlese
from zurueck_rechner import Zurück_Rechner
from ausgabe import Ausgabe

#*************************************************************
# Belegung der Klassen
#*************************************************************
steuer = Steuer()
datei_einlese = Datei_einlese()
zurück_rechner = Zurück_Rechner()
ausgabe = Ausgabe()

#*************************************************************
# Ausgabe an
#*************************************************************



#*************************************************************
# Berechnung der Startzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Startzeit zu einem String "datum_zeit"
#*************************************************************
dt_start = datetime.datetime.now()
lt_start = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
datum_zeit = "Datum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)


#*************************************************************
# öffnen der Log-Datei
#*************************************************************
fobj_log = open("fourier_analyse_2.log","w")

#*************************************************************
# Schreiben von Datum und Zeit des Programmstarts 
# in die Logdatei 
#*************************************************************
fobj_log.write("Anfang: "+ "\n" + datum_zeit)
fobj_log.write("\n")
#*************************************************************
# Prüfung, ob Steuerdatei erfolgreich geöffnet wurde
#*************************************************************

if steuer.steuer_input():
  fobj_log.write( "Einlesen der Steuerdatei funktionierte\n")
  datei_einlese.parameter_datei_input(steuer.parameter_datei)

  if datei_einlese.datei_input(steuer.cosinus_anteil_temp_datei):
    fobj_log.write( "Datei existiert\n")
    cos_temp = datei_einlese.spektral_wert
  if datei_einlese.datei_input(steuer.sinus_anteil_temp_datei):
    fobj_log.write( "Datei existiert\n")
    sin_temp = datei_einlese.spektral_wert
  zurück_rechner.fourier_zurück(steuer.spektrum_wähler, steuer.cos_min, steuer.cos_max, steuer.sin_min, steuer.sin_max, steuer.alle_min, steuer.alle_max, datei_einlese.m_max,\
  datei_einlese.x_min,datei_einlese.x_max, cos_temp, sin_temp)  
  fourier_temp_cos =  zurück_rechner.F_cos
  fourier_temp_sin =  zurück_rechner.F_sin 
  fourier_temp_alle =  zurück_rechner.F_alle
  
  
  if datei_einlese.datei_input(steuer.cosinus_anteil_meeresspiegel_datei):
    fobj_log.write( "Datei existiert\n")
    cos_meeres_spiegel = datei_einlese.spektral_wert 
  if datei_einlese.datei_input(steuer.sinus_anteil_meeresspiegel_datei):
    fobj_log.write( "Datei existiert\n")    
    sin_meeres_spiegel = datei_einlese.spektral_wert 
  zurück_rechner.fourier_zurück(steuer.spektrum_wähler, steuer.cos_min, steuer.cos_max, steuer.sin_min, steuer.sin_max, steuer.alle_min, steuer.alle_max, datei_einlese.m_max,\
  datei_einlese.x_min, datei_einlese.x_max, cos_meeres_spiegel, sin_meeres_spiegel) 
  fourier_meeresspiegel_cos =  zurück_rechner.F_cos
  fourier_meeresspiegel_sin =  zurück_rechner.F_sin 
  fourier_meeresspiegel_alle =  zurück_rechner.F_alle   
      
  
#*************************************************************
# Ausgabe der Lösung auf Schirm, in Datei, als Graphik 
#*************************************************************
  if steuer.schirm_ausgabe_wähler:  
    ausgabe.schirm_ausgabe(zurück_rechner.x_neu,fourier_temp_cos,fourier_temp_sin,fourier_temp_alle, fourier_meeresspiegel_cos,fourier_meeresspiegel_sin,fourier_meeresspiegel_alle)
    
  if steuer.datei_ausgabe_wähler: 
    ausgabe.datei_ausgabe(steuer.ausgabe_datei,zurück_rechner.x_neu,fourier_temp_cos,fourier_temp_sin,fourier_temp_alle, fourier_meeresspiegel_cos,fourier_meeresspiegel_sin,\
    fourier_meeresspiegel_alle)
    
  if steuer.graphik_ausgabe_wähler: 
    ausgabe.graphik_ausgabe(zurück_rechner.x_neu,fourier_temp_cos,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_ausgabe_datei_name,"cos_temp", steuer.graphik_ausgabe_datei_format)
    ausgabe.graphik_ausgabe(zurück_rechner.x_neu,fourier_temp_sin,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_ausgabe_datei_name,"sin_temp", steuer.graphik_ausgabe_datei_format)
    ausgabe.graphik_ausgabe(zurück_rechner.x_neu,fourier_temp_alle,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_ausgabe_datei_name,"gesamt_temp", steuer.graphik_ausgabe_datei_format)
    ausgabe.graphik_ausgabe(zurück_rechner.x_neu,fourier_meeresspiegel_cos,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_ausgabe_datei_name,"cos_meeresspiegel",\
    steuer.graphik_ausgabe_datei_format)  
    ausgabe.graphik_ausgabe(zurück_rechner.x_neu,fourier_meeresspiegel_sin,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_ausgabe_datei_name,"sin_meeresspiegel",\
    steuer.graphik_ausgabe_datei_format)
    ausgabe.graphik_ausgabe(zurück_rechner.x_neu,fourier_meeresspiegel_alle,steuer.graphik_datei_ausgabe_wähler ,steuer.graphik_ausgabe_datei_name,"gesamt_meeresspiegel",\
    steuer.graphik_ausgabe_datei_format)   

else:
  fobj_log.write( "Einlesen der Steuerdatei funktionierte nicht\n")    
   

#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit"
#*************************************************************
lt_end = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
datum_zeit = "Datum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
dauer = dt_end - dt_start

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
fobj_log.write("Ende: "+ "\n" +datum_zeit + "\n")
fobj_log.write("Rechendauer: "+ "\n" + str(dauer))

#*************************************************************
# Schließen der Logdatei
#*************************************************************
fobj_log.close()

#*************************************************************
#Programmende
#*************************************************************



