#*************************************************************
# Progamm:			fourier_2
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Einlesen der Steuerdaten	
# Name dieser Datei:		steuer.py
# Versionsnummer:		1
# Wird aufgerufen von:		fourier_2_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		08.11.2022
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os


class Steuer:
  #Konstruktormethode
  def __init__(self):		
    print("Steuerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Steuerobjekt entfernt")  

#*************************************************************
# Abschalten der GUI-Funktionen nach Gebrauch
#*************************************************************     
  def ändern(self):
    self.eingabe_gui.destroy()   
    print(self.eingabe_neu())
        
  def ende(self):
    self.eingabe_gui.destroy()     
    
  def ende_neu(self):
    self.eingabe_gui_neu.destroy()  

#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def steuer_input(self):
    self.rückgabeliste = list(range(5))
    self.rückgabeliste[0] = True                                   # Einlesen von Steuerdatei korrekt            True/False
    self.rückgabeliste[1] = "Steuerdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen aus Steuerdatei  Text
    self.rückgabeliste[2] = False                                  # Manuelle Änderung                           True/False
    self.rückgabeliste[3] = True                                   # Manuelle Änderung korrekt                   True/False
    self.rückgabeliste[4] = "Keine Fehler in der Änderung"         # Fehlermeldung für manuelle Änderung         Text  
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("steuer.txt"): 
      print("Steuerdatei ist vorhanden")

#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************    
      import tkinter
      self.eingabe_gui = tkinter.Tk()  
      print("Eingabedaten werden eingelesen")
      self.zeilen_zähler = 0
      fobj_in = open("steuer.txt","r")       
      for line in fobj_in:
        self.zeilen_zähler+=1
      fobj_in.close()  
      
      self.anzeige_liste = list(range(self.zeilen_zähler)) 
      self.zeilen_zähler = 0
#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      fobj_in = open("steuer.txt","r") 
#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
      
      for zeile in fobj_in:
        self.anzeige_liste[self.zeilen_zähler] = zeile[:-1]
        if self.zeilen_zähler == 1:
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
          self.ausgabe_datei = zeile[:-1]
          
        if self.zeilen_zähler == 3:
          self.graphik_ausgabe_datei_name = zeile[:-1]

        if self.zeilen_zähler == 5:
          self.graphik_ausgabe_datei_format = zeile[:-1] 
          self.graphik_formate_zulässig = set(['eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'])
          if self.graphik_ausgabe_datei_format in self.graphik_formate_zulässig:
            pass
          else:
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!"

        if self.zeilen_zähler == 7:
          self.spektrum_wähler = self.bool_function(zeile[:-1])    
                          
        if self.zeilen_zähler == 9:
          try:
            self.cos_min = int(zeile[:-1])
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen cos_min ist keine ganze Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 11:
          try:
            self.cos_max = int(zeile[:-1])   
            if self.cos_min <= self.cos_max:
              self.cos_min_zwischen = self.cos_min
              self.cos_max_zwischen = self.cos_max
            else:
              self.rückgabeliste[0] = False  
              self.rückgabeliste[1] = "Fehler in Steuerdatei: cos_min muß kleiner cos_max sein!\nProgramm bricht ab!"
          except:
            self.rückgabeliste[0] = False  
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen cos_max ist keine ganze Zahl!\nProgramm bricht ab!"
                               
        if self.zeilen_zähler == 13:
          try:
            self.sin_min = int(zeile[:-1])
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen cos_min ist keine ganze Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 15:
          try:
            self.sin_max = int(zeile[:-1])   
            if self.sin_min < self.sin_max:  # Sinus: Ausgabeprozedur schmiert bei Ausgabe ab, wenn sin_min = sin_max  
              self.sin_min_zwischen = self.sin_min
              self.sin_max_zwischen = self.sin_max
            else:
              self.rückgabeliste[0] = False  
              self.rückgabeliste[1] = "Fehler in Steuerdatei: sin_min muß kleiner sin_max sein!\nProgramm bricht ab!"
          except:
            self.rückgabeliste[0] = False  
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen sin_max ist keine ganze Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 17:
          try:
            self.alle_min = int(zeile[:-1])
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen cos_min ist keine ganze Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 19:
          try:
            self.alle_max = int(zeile[:-1])   
            if self.alle_min <= self.alle_max:
              self.alle_min_zwischen = self.alle_min
              self.alle_max_zwischen = self.alle_max
            else:
              self.rückgabeliste[0] = False  
              self.rückgabeliste[1] = "Fehler in Steuerdatei: sin_min muß kleiner sin_max sein!\nProgramm bricht ab!"
          except:
            self.rückgabeliste[0] = False  
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen sin_max ist keine ganze Zahl!\nProgramm bricht ab!"
        if self.zeilen_zähler == 21:
          self.parameter_datei = zeile[:-1]
          
          
        if self.zeilen_zähler == 23:
          self.cosinus_anteil_temp_datei = zeile[:-1]
        if self.zeilen_zähler == 25:
          self.sinus_anteil_temp_datei = zeile[:-1] 
        if self.zeilen_zähler == 27:
          self.cosinus_anteil_meeresspiegel_datei = zeile[:-1]
        if self.zeilen_zähler == 29:
          self.sinus_anteil_meeresspiegel_datei = zeile[:-1]               
        if self.zeilen_zähler == 31:
          self.schirm_ausgabe_wähler = self.bool_function(zeile[:-1]) 
        if self.zeilen_zähler == 33:
          self.datei_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 35:
          self.graphik_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 37:
          self.graphik_datei_ausgabe_wähler = self.bool_function(zeile[:-1])              
        self.zeilen_zähler += 1    
      fobj_in.close()

#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
#*************************************************************   
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui, text = self.anzeige_liste[i])
        
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
          #lb["font"] = "Arial 6 bold"
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten und 
# zum Start der Berechnungen
#*************************************************************
      weiter_button = tkinter.Button(self.eingabe_gui, text = "weiter", command = self.ende)
      weiter_button.grid(row=int(i/2+1), column=0, padx='1', pady='1', sticky='ew')
      ändern_button = tkinter.Button(self.eingabe_gui, text = "Eingabe ändern", command = self.ändern)
      ändern_button.grid(row=int(i/2+1), column=1, padx='1', pady='1', sticky='ew')
      #Endlosschleife
      self.eingabe_gui.mainloop()
      print("Einlesen der Steuerdaten o.k.")

    else:
      self.rückgabeliste[0] = False 
      self.rückgabeliste[1] = "Steuerdatei ist nicht vorhanden!"  
      
    self.rückgabewert = self.rückgabeliste[0]  
    return self.rückgabewert

  def übernahme(self): 
    dummy = self.änderungs_feld_ausgabe_datei.get()
#*************************************************************
# Test ob in das Feld etwas eingeschrieben wurde
# wenn nicht, dann dummy != "" False
#*************************************************************    
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.ausgabe_datei = dummy
      print("ausgabe_datei geändert:", self.ausgabe_datei) 
    else:
      print("Keine Änderung der Variablen")
            
    dummy = self.änderungs_feld_graphik_ausgabe_datei_name.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.graphik_ausgabe_datei_name = dummy
      print("graphik_datei_name geändert:", self.graphik_ausgabe_datei_name) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_ausgabe_datei_format.get()
    if dummy != "": 
      self.rückgabeliste[2] = True  
      if dummy in self.graphik_formate_zulässig:
        self.graphik_ausgabe_datei_format = dummy
      else:
        self.rückgabeliste[3] = False 
        self.rückgabeliste[4] = "Fehler in Eingabe: Python unterstützt das Graphikformat nicht!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      print("graphik_datei_format geändert:",  self.graphik_ausgabe_datei_format) 
    else:
      print("Keine Änderung der Variablen") 

    dummy = self.änderungs_feld_spektrum_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.spektrum_wähler = self.bool_function(dummy)
      print("spektrum_wähler geändert:", self.spektrum_wähler) 
    else:
      print("Keine Änderung der Variablen spektrum_wähler") 
#*************************************************************
# Test ob in das Feld eingeschriebene(s) Zeichen eine Zahl ist/sind
# d.h. zu float konvertierbar ist
#*************************************************************

    dummy = self.änderungs_feld_cos_min.get()
    if dummy != "":  
      try:
        self.cos_min = int(dummy)
        self.rückgabeliste[2] = True 
        print("cos_min geändert:",  self.cos_min) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen cos_min ist keine ganze Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")         
      
    dummy = self.änderungs_feld_cos_max.get()
    if dummy != "":  
      try:
        self.cos_max = int(dummy)      
        self.rückgabeliste[2] = True 
        print("cos_max geändert:",  self.cos_max) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen cos_max ist keine ganze Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")  

    if self.cos_min > self.cos_max:
      self.cos_min = self.cos_min_zwischen
      self.cos_max = self.cos_max_zwischen 
      
    dummy = self.änderungs_feld_sin_min.get()
    if dummy != "":  
      try:
        self.sin_min = int(dummy)
        self.rückgabeliste[2] = True 
        print("sin_min geändert:",  self.sin_min) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen sin_min ist keine ganze Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")         

    
      
    dummy = self.änderungs_feld_sin_max.get()
    if dummy != "":  
      try:
        self.sin_max = int(dummy)
        self.rückgabeliste[2] = True 
        print("sin_max geändert:",  self.sin_max) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen sin_max ist keine ganze Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen sin_max")  

    if self.sin_min > self.sin_max:   # Sinus: Ausgabeprozedur schmiert bei Ausgabe ab, wenn sin_min = sin_max  
      self.sin_min = self.sin_min_zwischen
      self.sin_max = self.sin_max_zwischen
      
    dummy = self.änderungs_feld_alle_min.get()
    if dummy != "":  
      try:
        self.alle_min = int(dummy)
        self.rückgabeliste[2] = True 
        print("alle_min geändert:",  self.alle_min) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen alle_min ist keine ganze Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")         
      
    dummy = self.änderungs_feld_alle_max.get()
    if dummy != "":  
      try:
        self.alle_max = int(dummy)
        self.rückgabeliste[2] = True 
        print("alle_max geändert:",  self.alle_max) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen alle_max ist keine ganze Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen")  

    if self.alle_min > self.alle_max:
      self.alle_min = self.alle_min_zwischen
      self.alle_max = self.alle_max_zwischen


    dummy = self.änderungs_feld_parameter_datei.get()  
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.parameter_datei = dummy
      print("ausgabe_datei geändert:", self.parameter_datei) 
    else:
      print("Keine Änderung der Variablen parameter_datei")
      
    dummy = self.änderungs_feld_cosinus_anteil_temp_datei.get()  
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.cosinus_anteil_temp_datei = dummy
      print("ausgabe_datei geändert:", self.cosinus_anteil_temp_datei) 
    else:
      print("Keine Änderung der Variablen")    
      
    dummy = self.änderungs_feld_sinus_anteil_temp_datei.get()    
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.sinus_anteil_temp_datei = dummy
      print("ausgabe_datei geändert:", self.sinus_anteil_temp_datei) 
    else:
      print("Keine Änderung der Variablen")
      
            
    dummy = self.änderungs_feld_cosinus_anteil_meeresspiegel_datei.get()   
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.cosinus_anteil_meeresspiegel_datei = dummy
      print("ausgabe_datei geändert:", self.cosinus_anteil_meeresspiegel_datei) 
    else:
      print("Keine Änderung der Variablen")
      
    dummy = self.änderungs_feld_sinus_anteil_meeresspiegel_datei.get()   
    if dummy != "":  
      self.rückgabeliste[2] = True         
      self.sinus_anteil_meeresspiegel_datei = dummy
      print("ausgabe_datei geändert:", self.sinus_anteil_meeresspiegel_datei) 
    else:
      print("Keine Änderung der Variablen")      
                 
      
    dummy = self.änderungs_feld_schirm_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.schirm_ausgabe_wähler = self.bool_function(dummy)
      print("schirm_ausgabe_wähler geändert:",  self.schirm_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_datei_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.datei_ausgabe_wähler =self.bool_function(dummy)
      print("datei_ausgabe_wähler geändert:", self.datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen")                          
                                    
    dummy = self.änderungs_feld_graphik_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.graphik_ausgabe_wähler = self.bool_function(dummy)
      print("graphik_ausgabe_wähler geändert:", self.graphik_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 
      
    dummy = self.änderungs_feld_graphik_datei_ausgabe_wähler.get()
    if dummy != "":  
      self.rückgabeliste[2] = True 
      self.graphik_datei_ausgabe_wähler = self.bool_function(dummy)
      print("graphik_datei_ausgabe_wähler geändert:", self.graphik_datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 


#*************************************************************
# Abspeichern der veränderten Eingabedaten in eine neue Datei
#*************************************************************
    if(self.rückgabeliste[2] == True ):
      fobj_out = open("steuer_neu.txt","w")   
      fobj_out.write("Name der Ausgabedatei:\n")
      fobj_out.write(self.ausgabe_datei)
      fobj_out.write("\n")
      fobj_out.write("Name der Graphikausgabedatei:\n")
      fobj_out.write(self.graphik_ausgabe_datei_name) 
      fobj_out.write("\n")
      fobj_out.write("Format der Graphikausgabedatei:\n")
      fobj_out.write(self.graphik_ausgabe_datei_format)
      fobj_out.write("\n")
      fobj_out.write("Wähler Ganzens Spektrum:\n")
      fobj_out.write(str(self.spektrum_wähler)) 
      fobj_out.write("\n")
      fobj_out.write("cos_min Cosinus:\n")
      fobj_out.write(str("%8i" %self.cos_min))
      fobj_out.write("\n")
      fobj_out.write("cos_max Cosinus:\n")
      fobj_out.write(str("%8i" %self.cos_max))
      fobj_out.write("\n")
      fobj_out.write("sin_min Sinus:\n")
      fobj_out.write(str("%8i" %self.sin_min))
      fobj_out.write("\n")
      fobj_out.write("sin_max Sinus:\n")
      fobj_out.write(str("%8i" %self.sin_max))
      fobj_out.write("\n")  
      fobj_out.write("alle_min Summe:\n")
      fobj_out.write(str("%8i" %self.sin_min))
      fobj_out.write("\n")
      fobj_out.write("alle_max Summe:\n")
      fobj_out.write(str("%8i" %self.sin_max))
      fobj_out.write("\n")  
      fobj_out.write("Parameterdatei:\n")
      fobj_out.write(self.parameter_datei)
      fobj_out.write("\n")
      fobj_out.write("\n")        
      fobj_out.write("Name der Ausgabedatei:\n")
      fobj_out.write(self.cosinus_anteil_temp_datei)
      fobj_out.write("\n")
      fobj_out.write("Name der Ausgabedatei:\n")
      fobj_out.write(self.sinus_anteil_temp_datei)
      fobj_out.write("\n")
      fobj_out.write("Name der Ausgabedatei:\n")
      fobj_out.write(self.cosinus_anteil_meeresspiegel_datei)
      fobj_out.write("\n")
      fobj_out.write("Name der Ausgabedatei:\n")
      fobj_out.write(self.sinus_anteil_meeresspiegel_datei)
      fobj_out.write("\n")                        
      fobj_out.write("Bildschirmausgabe?:\n")
      fobj_out.write(str(self.schirm_ausgabe_wähler)) 
      fobj_out.write("\n")     
      fobj_out.write("Dateiausgabe?:\n")
      fobj_out.write(str(self.datei_ausgabe_wähler)) 
      fobj_out.write("\n")
      fobj_out.write("Graphikausgabe?:\n")
      fobj_out.write(str(self.graphik_ausgabe_wähler)) 
      fobj_out.write("Graphikdateiausgabe?:\n")
      fobj_out.write(str(self.graphik_datei_ausgabe_wähler)) 
      fobj_out.write("\n")                      
      fobj_out.close   
    else:
      pass
                                
#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
# sowie der Möglichkeit, andere Eingabedaten einzugeben
#*************************************************************    
  def eingabe_neu(self):
    try:
      import tkinter
      self.eingabe_gui_neu = tkinter.Tk() 
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui_neu, text = self.anzeige_liste[i])
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
      
      self.änderungs_feld_ausgabe_datei = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_ausgabe_datei_name = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_ausgabe_datei_format = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_spektrum_wähler = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_cos_min= tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_cos_max = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_sin_min = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_sin_max = tkinter.Entry(self.eingabe_gui_neu)  
      self.änderungs_feld_alle_min = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_alle_max = tkinter.Entry(self.eingabe_gui_neu) 
      self.änderungs_feld_parameter_datei = tkinter.Entry(self.eingabe_gui_neu)          
      self.änderungs_feld_cosinus_anteil_temp_datei = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_sinus_anteil_temp_datei = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_cosinus_anteil_meeresspiegel_datei = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_sinus_anteil_meeresspiegel_datei = tkinter.Entry(self.eingabe_gui_neu)                        
      self.änderungs_feld_schirm_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_datei_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      
      self.änderungs_feld_ausgabe_datei.grid(row=0, column=2, padx='1', pady='1', sticky='ew')    
      self.änderungs_feld_graphik_ausgabe_datei_name.grid(row=1, column=2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_graphik_ausgabe_datei_format.grid(row=2, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_spektrum_wähler.grid(row=3, column=2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_cos_min.grid(row=4, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_cos_max.grid(row=5, column=2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_sin_min .grid(row=6, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_sin_max.grid(row=7, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_alle_min .grid(row=8, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_alle_max.grid(row=9, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_parameter_datei.grid(row=10, column=2, padx='1', pady='1', sticky='ew')            
      self.änderungs_feld_cosinus_anteil_temp_datei.grid(row=11, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_sinus_anteil_temp_datei.grid(row=12, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_cosinus_anteil_meeresspiegel_datei.grid(row=13, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_sinus_anteil_meeresspiegel_datei.grid(row=14, column=2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_schirm_ausgabe_wähler.grid(row=15, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler.grid(row=16, column=2, padx='1', pady='1', sticky='ew')   
      self.änderungs_feld_graphik_ausgabe_wähler.grid(row=17, column=2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_datei_ausgabe_wähler.grid(row=18, column=2, padx='1', pady='1', sticky='ew')
 
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten
# Button zur Übernahme der geänderten Eingabedaten
# zum Start der Berechnungen
#*************************************************************      
      weiter_button = tkinter.Button(self.eingabe_gui_neu, text = "weiter", command = self.ende_neu)
      weiter_button.grid(row=19, column=0, padx='1', pady='1', sticky='ew')
      übernahme_button = tkinter.Button(self.eingabe_gui_neu, text = "übernehmen", command = self.übernahme)
      übernahme_button.grid(row=19, column=2, padx='1', pady='1', sticky='ew')
      
      #Endlosschleife
      self.eingabe_gui_neu.mainloop()
           
      print("Einlesen o.k.")
      self.rückgabewert = True
  
    except:
      print("Fehler beim Dateieinlesen")
      self.rückgabewert = False
    return self.rückgabewert   

     
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return True

